Team13-SocialMedia/SocialMedia.Web/Controllers/HomeController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SocialMedia.Services.Contracts;
using SocialMedia.Services.DTOs;
using SocialMedia.Web.Mapper;
using SocialMedia.Web.Models;
using System.Diagnostics;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace SocialMedia.Web.Controllers
{
    [Authorize]
    public class HomeController : Controller
    {
        private readonly IPostService _postService;
        private readonly IUserService _userService;
        private readonly IRatingService _ratingService;
        private readonly ICommentService _commentService;

        public HomeController(IPostService postService, IUserService userService,
            ICommentService commentService, IRatingService ratingService)
        {
            _postService = postService;
            _commentService = commentService;
            _ratingService = ratingService;
            _userService = userService;
        }

        private int CurentUserId => int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

        private async Task<UserDTO> GetCurrentUser()
        {
            return await _userService.Get(CurentUserId);
        }

        public async Task<IActionResult> Index(int pageSize = 20, int page = 1)
        {
            UserDTO current = await GetCurrentUser();

            if (current == null)
                return RedirectToAction(nameof(PageNotFound));

            ViewData["Posts"] = (await _postService.GenerateFeed(current.Id, pageSize, page))
                .Select(x => x.ToViewModel())
                .OrderByDescending(x => x.EngagementFactor);

            return View(current.ToViewModel(""));
        }

        public async Task<IActionResult> GetImage(int userId)
        {
            if (userId == -1)
                return File(new byte[1], "image/png");

            UserDTO user = await _userService.Get(userId);

            return File(user.ProfilePicture, user.PictureType);
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel
            {
                RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier
            });
        }

        public IActionResult PageNotFound()
        {
            return View();
        }
    }
}

Team13-SocialMedia/SocialMedia.Web/Controllers/PostController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using SocialMedia.Services.Contracts;
using SocialMedia.Services.DTOs;
using SocialMedia.Web.Mapper;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace SocialMedia.Web.Controllers
{
    public class PostController : Controller
    {
        private readonly IPostService _postService;
        private readonly IUserService _userService;
        private readonly IRatingService _ratingService;
        private readonly ICommentService _commentService;
        private readonly IPictureService _pictureService;

        public PostController(IPostService postService, IUserService userService,
            ICommentService commentService, IRatingService ratingService,
            IPictureService pictureService)
        {
            _postService = postService;
            _commentService = commentService;
            _ratingService = ratingService;
            _userService = userService;
            _pictureService = pictureService;
        }

        private int CurentUserId => int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

        private async Task<UserDTO> GetCurrentUser()
        {
            return await _userService.Get(CurentUserId);
        }

        public async Task<IActionResult> Index(string sortBy = "likes", string order = "desc",
            string searchQuery = "", int pageSize = 2, int page = 1)
        {
            ViewData["Posts"] = (await _postService.GetAll(sortBy, order,
            searchQuery, pageSize, page))
            .Select(x => x.ToViewModel());

            return View();
        }

        public async Task<IActionResult> GetImage(int postId)
        {
            PostDTO post = await _postService.GetPost(postId);

            if (post == null)
                return RedirectToAction("PageNotFound", "Home");

            return File(post.Picture, post.PictureType);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> SubmitPost(IFormFile file)
        {
            UserDTO tmpUser = await GetCurrentUser();

            (byte[] Data, string DataType) data = await _pictureService.GetFileData(file);

            PostDTO post = new PostDTO
            {
                UserFirstName = tmpUser.FirstName,
                UserLastName = tmpUser.LastName,
                UserId = tmpUser.Id,
                Body = Request.Form["postBody"],
                Title = Request.Form["postTitle"],
                Picture = data.Data,
                PictureType = data.DataType
            };

            await _postService.CreatePost(post);

            return Ok();
        }

        [HttpPost]
        public async Task<IActionResult> PostComment()
        {
            int userId = int.Parse(Request.Form["userId"]);
            int postId = int.Parse(Request.Form["postId"]);
            string text = Request.Form["commentText"];

            await _commentService.ReplyToPost(postId, userId, text);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> LikePost()
        {
            int postId = int.Parse(Request.Form["postId"]);
            await _ratingService.LikePost(this.CurentUserId, postId);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> DislikePost()
        {
            int postId = int.Parse(Request.Form["postId"]);
            await _ratingService.DislikePost(this.CurentUserId, postId);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> LikeComment()
        {
            int commentId = int.Parse(Request.Form["commentId"]);
            await _ratingService.LikeComment(this.CurentUserId, commentId);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> DislikeComment()
        {
            int commentId = int.Parse(Request.Form["commentId"]);
            await _ratingService.DislikeComment(this.CurentUserId, commentId);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> DeleteComment()
        {
            int commentId = int.Parse(Request.Form["commentId"]);
            await _commentService.Remove(commentId);

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        public async Task<IActionResult> DeletePost()
        {
            int postId = int.Parse(Request.Form["postId"]);
            await _postService.DeletePost(postId);

            return RedirectToAction(nameof(Index));
        }
    }
}

Team13-SocialMedia/SocialMedia.Web/Controllers/UserController.cs
using Microsoft.AspNetCore.Mvc;
using SocialMedia.Services.Contracts;
using SocialMedia.Services.DTOs;
using SocialMedia.Web.Mapper;
using SocialMedia.Web.Models;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace SocialMedia.Web.Controllers
{
    public class UserController : Controller
    {
        private readonly IUserService _userService;
        private readonly IFriendsService _friendsService;
        private readonly IPostService _postService;

        public UserController(IUserService userService, IFriendsService friendsService, IPostService postService)
        {
            _userService = userService;
            _friendsService = friendsService;
            _postService = postService;
        }

        public async Task<IActionResult> Index(int id)
        {
            ViewData["Posts"] = (await _postService.GetUserPosts(id))
                .Select(x => x.ToViewModel());

            return await VerifyAccessibility(id);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Index(PostDTO model, int id)
        {
            if (ModelState.IsValid)
            {
                model.UserId = id;

                await _postService.CreatePost(model);
            }

            return RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Search(string sortBy = "Id", string order = "asc", string searchQuery = "")
        {
            ViewData["Users"] = (await _userService.GetMany(sortBy, order, searchQuery))
                .Select(x => x.ToViewModel(""));

            return View();
        }

        public async Task<IActionResult> Friends(int id)
        {
            ViewData["Friends"] = (await _friendsService.GetFriends(id))
                .Select(x => x.ToViewModel(""));

            return await VerifyAccessibility(id);
        }

        public async Task<IActionResult> About(int id)
        {
            return await VerifyAccessibility(id);
        }

        public ActionResult Restricted()
        {
            return View();
        }

        /// <summary>
        /// Restricts access to page based on profile privacy setting.
        /// </summary>
        /// <param name="id"></param>
        /// <returns>Restricted View if profile is restricted for current user.</returns>
        private async Task<IActionResult> VerifyAccessibility(int id)
        {
            bool isCurrentUserLoggedIn = int.TryParse(
                User.FindFirstValue(ClaimTypes.NameIdentifier),
                out int currentUserId);

            if (id == currentUserId)
                return RedirectToAction("Index", "Profile");

            var userDTO = await _userService.Get(id);

            if (userDTO == null)
                return RedirectToAction("PageNotFound", "Home");

            UserViewModel user = userDTO.ToViewModel("");

            if (user.PrivacySetting == 2)
            {
                return View(user);
            }
            else if (user.PrivacySetting == 1)
            {
                if (isCurrentUserLoggedIn)
                {
                    if (await _friendsService.IsFriendsWith(currentUserId, id))
                    {
                        return View(user);
                    }
                }
            }

            return RedirectToAction(nameof(Restricted));
        }
    }
}

Team13-SocialMedia/SocialMedia.Web/Views/Home/Index.cshtml
@model UserViewModel
@using SocialMedia.Web.Models

@{
    ViewData["Title"] = "Home Page";
}

<section>
    <div class="gap2 gray-bg">
        <div class="container-fluid">
            <div class="row">
                <div class="col-lg-12">
                    <div class="row merged20" id="page-contents">
                        <div class="col-lg-3">
                            <aside class="sidebar static left">
                                <div class="widget stick-widget">
                                    <h4 class="widget-title">Who's following</h4>
                                    <ul class="followers">
                                    </ul>
                                </div>
                            </aside>
                        </div>
                        <div class="col-lg-6">
                            <div class="central-meta">
                                <div class="new-postbox">
                                    <figure>
                                        <img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                                    </figure>
                                    <div class="newpst-input">
                                        <form asp-controller="Post" asp-action="SubmitPost" method="post" enctype="multipart/form-data">
                                            <textarea name="postTitle" rows="1" placeholder="Title"></textarea>
                                            <textarea name="postBody" rows="2" placeholder="Share your thoughts."></textarea>
                                            <div class="attachments">
                                                <ul>
                                                    <li>
                                                        <i class="fa fa-image"></i>
                                                        <label class="fileContainer">
                                                            <input type="file" name="file">
                                                        </label>
                                                    </li>
                                                    <li>
                                                        <button type="submit">Post</button>
                                                    </li>
                                                </ul>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>

                            @foreach (PostViewModel post in ViewBag.Posts)
                            {
                                <div class="central-meta item">
                                    <div class="user-post">
                                        <div class="friend-info">
                                            <figure>
                                                <img src="@Url.Action("GetImage", "Home", new { userId = post.UserId })" onerror='this.src="/images/profile-icon.png"' alt="">
                                            </figure>
                                            <div class="friend-name">
                                                <ins><a asp-controller="User" asp-action="Index" asp-route-id="@post.UserId" title="">@post.Title</a></ins>
                                                <span>@post.UserFirstName @post.UserLastName - @post.CreatedOn.ToLongDateString()</span>
                                                @if (Model.Id == post.UserId)
                                                {
                                                    <span class="dislike" data-toggle="tooltip" title="" data-original-title="Delete" onclick='ajaxDeletePost(@post.Id)'>
                                                        <i class="ti-trash"></i>
                                                    </span>
                                                }
                                            </div>
                                            <div class="post-meta">
                                                <div class="we-video-info">
                                                    <img src="@Url.Action("GetImage", "Post", new { postId = post.Id })" onerror='this.src=""' alt="">
                                                    <div class="description">
                                                        <p>
                                                            @post.Body
                                                        </p>
                                                    </div>
                                                    <ul>
                                                        <li>
                                                            <span class="comment" data-toggle="tooltip" title="" data-original-title="Comments">
                                                                <i class="ti-comments"></i>
                                                                <ins>@post.Comments.Count</ins>
                                                            </span>
                                                        </li>
                                                        <li>
                                                            <span class="like" data-toggle="tooltip" title="" data-original-title="Like" onclick='ajaxLikePost(@post.Id)'>
                                                                <i class="ti-heart"></i>
                                                                <ins>@post.Likes</ins>
                                                            </span>
                                                        </li>
                                                        <li>
                                                            <span class="dislike" data-toggle="tooltip" title="" data-original-title="Dislike" onclick='ajaxDislikePost(@post.Id)'>
                                                                <i class="ti-heart-broken"></i>
                                                                <ins>@post.Dislikes</ins>
                                                            </span>
                                                        </li>
                                                    </ul>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="coment-area">
                                            <ul class="we-comet" id="commentSection">
                                                @foreach (CommentViewModel comment in post.Comments)
                                                {
                                                    <li>
                                                        <div class="comet-avatar">
                                                            <img src="@Url.Action("GetImage", "Home", new { userId = comment.CommenterId})" onerror='this.src="/images/profile-icon.png"' alt="">
                                                        </div>
                                                        <div class="we-comment">
                                                            <div class="coment-head">
                                                                <h5><a href="time-line.html" title="">@comment.CommenterName</a></h5>
                                                                <span>@comment.CreatedOn</span>
                                                                <span class="like" data-toggle="tooltip" title="" data-original-title="Like" onclick='ajaxLikeComment(@comment.Id)'>
                                                                    <i class="ti-thumb-up"></i>
                                                                    <ins>@comment.Likes</ins>
                                                                </span>
                                                                <span class="dislike" data-toggle="tooltip" title="" data-original-title="Dislike" onclick='ajaxDislikeComment(@comment.Id)'>
                                                                    <i class="ti-thumb-down"></i>
                                                                    <ins>@comment.Dislikes</ins>
                                                                </span>
                                                                @if (Model.Id == comment.CommenterId)
                                                                {
                                                                    <span class="dislike" data-toggle="tooltip" title="" data-original-title="Delete" onclick='ajaxDeleteComment(@comment.Id)'>
                                                                        <i class="ti-trash"></i>
                                                                    </span>
                                                                }
                                                                <a class="we-reply" href="#" data-toggle="tooltip" title="" data-original-title="Reply"><i class="fa fa-reply"></i></a>
                                                            </div>
                                                            <p>@comment.Body</p>
                                                        </div>

                                                    </li>
                                                }
                                                <li class="post-comment">
                                                    <div class="comet-avatar">
                                                        <img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                                                    </div>
                                                    <div class="post-comt-box">
                                                        <form asp-action="PostComment" method="post" onkeydown='jqueryPost(this)'>
                                                            <input type="hidden" id="userId" name="userId" value="@Model.Id" />
                                                            <input type="hidden" id="postId" name="postId" value="@post.Id" />
                                                            <textarea placeholder="Comment as @Model.FirstName @Model.LastName" id="commentText" name="commentText"></textarea>
                                                        </form>
                                                    </div>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            }
                            </div>
                        <div class="col-lg-3">
                            <aside class="sidebar static right">
                                <div class="widget stick-widget">
                                    <h4 class="widget-title">My Page</h4>
                                    <div class="your-page">
                                        <figure>
                                            <a href="#" title=""><img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt=""></a>
                                        </figure>
                                        <div class="page-meta">
                                            <a asp-controller="User" asp-action="Index" asp-route-id="@Model.Id" title="" class="underline">@Model.FirstName @Model.LastName</a>
                                        </div>
                                        <div class="page-likes">
                                            <ul class="nav nav-tabs likes-btn">
                                                <li class="nav-item"><a class="active" href="#link1" data-toggle="tab">Likes</a></li>
                                                <li class="nav-item"><a class="" href="#link2" data-toggle="tab">Views</a></li>
                                            </ul>
                                            
                                            <div class="tab-content">
                                                <div class="tab-pane active fade show " id="link1">
                                                    <span><i class="ti-thumb-up"></i>0</span>
                                                    <a href="#" title="Likes">People liked your page</a>
                                                </div>
                                                <div class="tab-pane fade" id="link2">
                                                    <span><i class="ti-heart"></i>0</span>
                                                    <a href="#" title="Follows">People followed you</a>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </aside>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

Team13-SocialMedia/SocialMedia.Web/Views/Home/PageNotFound.cshtml
@{ 
    Layout = null;
}

<!DOCTYPE html>
<html lang="en">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <title>Page Not Found</title>
    <link rel="icon" href="~/images/fav.png" type="image/png" sizes="16x16">

    <link rel="stylesheet" href="~/css/main.min.css">
    <link rel="stylesheet" href="~/css/style.css">
    <link rel="stylesheet" href="~/css/color.css">
    <link rel="stylesheet" href="~/css/responsive.css">

</head>
<body>
    <div class="theme-layout">
        <div class="container-fluid pdng0">
            <div class="row">
                <div class="col-lg-12">
                    <div class="error-page">
                        <div class="bg-image" style="background-image: url(/images/resources/404.jpg)"></div>
                        <div class="error-meta">
                            <h1>404</h1>
                            <span>we couldn't find that page</span>
                            <a asp-controller="Home" asp-action="Index" title="" data-ripple="">Go Back</a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</body>

</html>